package de.unikoblenz.fgbks.core.dmn.domain.vdmn;

import de.unikoblenz.fgbks.core.dmn.domain.ids.DecisionTableId;
import de.unikoblenz.fgbks.core.dmn.domain.ids.RuleId;
import java.util.List;
import java.util.stream.Collectors;
import org.camunda.bpm.model.dmn.HitPolicy;

public interface VDmnDecisionTable extends VDmnElement {

  VDmnDecision getDecision();

  HitPolicy getHitPolicy();

  default DecisionTableId getDecisionTableId() {
    return (DecisionTableId) getId();
  }

  List<VDmnOutputColumn> getOutputColumns();

  List<VDmnInputColumn> getInputColumns();

  List<VDmnRule> getRules();

  default List<RuleId> getRulesIds() {
    return getRules().stream()
        .map(VDmnRule::getRuleId)
        .collect(Collectors.toList()); // TODO optimize (e.g. cache)
  }
}
