package de.unikoblenz.fgbks.core.dmn.domain.vdmn.impl;

import de.unikoblenz.fgbks.core.dmn.domain.ids.ColumnId;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnColumn;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnDecisionTable;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnValue;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VTypeRef;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public abstract class VDmnColumnImpl extends AbstractVDmnElement implements VDmnColumn {

  protected VDmnDecisionTable dmnDecisionTable;
  protected VTypeRef typeRef;
  protected List<VDmnValue> values;

  protected VDmnColumnImpl() {
    values = new ArrayList<>();
  }

  @Override
  public VDmnDecisionTable getDmnDecisionTable() {
    return dmnDecisionTable;
  }

  @Override
  public ColumnId getColumnId() {
    return (ColumnId) getId();
  }

  @Override
  public VTypeRef getTypeRef() {
    return typeRef;
  }

  @Override
  public List<VDmnValue> getValues() {
    return Collections.unmodifiableList(values);
  }
}
